// proxydll.cpp
#include <stdlib.h>
#include "stdafx.h"
#include "proxydll.h"

// global variables
#pragma data_seg (".d3d9_shared")
myIDirect3DDevice9* gl_pmyIDirect3DDevice9;
myIDirect3D9*       gl_pmyIDirect3D9;
HINSTANCE           gl_hOriginalDll;
HINSTANCE           gl_hThisInstance;
HHOOK               gl_hKbdHook;  
HHOOK               gl_hMouseHook;  
#pragma data_seg ()


LRESULT WINAPI CALLBACK KeyboardProc(int nCode,WPARAM wParam, LPARAM lParam);
LRESULT WINAPI CALLBACK MouseProc(int nCode,WPARAM wParam, LPARAM lParam);
LRESULT WINAPI CALLBACK MsgProc(int nCode,WPARAM wParam, LPARAM lParam);
extern BOOL action;
extern int _switch;
extern int _alt;
extern int clock_on;
extern int screenX, screenY;
extern DWORD_PTR xData;
extern DWORD_PTR xOff;
extern DWORD_PTR xBase;
extern int frun;
extern int order[21];

extern int Modifiers[21];
extern byte __alpha;

int k_activate;
int k_alphaplus;
int k_alphaminus;
int k_save;
int k_about;
int k_clock;
int k_switch;


BOOL _verbose;
BOOL _save;
BOOL __fadeIn;
BOOL __fadeOut;
BOOL _about = FALSE;

extern int __x;
extern int __y;
extern int __w;
extern int __h;
extern int _tx;
extern int _ty;

BOOL APIENTRY DllMain( HANDLE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved)
{
	// to avoid compiler lvl4 warnings 
    LPVOID lpDummy = lpReserved;
    lpDummy = NULL;
    
    switch (ul_reason_for_call)
	{
	    case DLL_PROCESS_ATTACH: 
			InitInstance(hModule); 
			break;
	    case DLL_PROCESS_DETACH: 
			ExitInstance(); 
			break;
        case DLL_THREAD_ATTACH:  
			break;
	    case DLL_THREAD_DETACH:  
			break;
	}
    return TRUE;
}

// Exported function (faking d3d9.dll's one-and-only export)
IDirect3D9* WINAPI Direct3DCreate9(UINT SDKVersion)
{
	if (!gl_hOriginalDll) LoadOriginalDll(); // looking for the "right d3d9.dll"
	
	// Hooking IDirect3D Object from Original Library
	typedef IDirect3D9 *(WINAPI* D3D9_Type)(UINT SDKVersion);
	D3D9_Type D3DCreate9_fn = (D3D9_Type) GetProcAddress( gl_hOriginalDll, "Direct3DCreate9");
    
    // Debug
	if (!D3DCreate9_fn) 
    {
        ::ExitProcess(0); // exit the hard way
    }
	
	// Request pointer from Original Dll. 
	IDirect3D9 *pIDirect3D9_orig = D3DCreate9_fn(SDKVersion);
	
	// Create my IDirect3D8 object and store pointer to original object there.
	// note: the object will delete itself once Ref count is zero (similar to COM objects)
	gl_pmyIDirect3D9 = new myIDirect3D9(pIDirect3D9_orig);
	
	// Return pointer to hooking Object instead of "real one"
	return (gl_pmyIDirect3D9);
}
/**********************************************************************************************************************/
void InitInstance(HANDLE hModule) 
{
	// Initialisation
	gl_hOriginalDll        = NULL;
	gl_hThisInstance       = NULL;
	gl_pmyIDirect3D9       = NULL;
	gl_pmyIDirect3DDevice9 = NULL;	
	gl_hKbdHook            = NULL;
	gl_hMouseHook          = NULL;
	// Storing Instance handle into global var

	gl_hThisInstance = (HINSTANCE)  hModule;

	gl_hKbdHook = SetWindowsHookEx(WH_KEYBOARD,(HOOKPROC)KeyboardProc,gl_hThisInstance,GetCurrentThreadId());
	gl_hMouseHook = SetWindowsHookEx(WH_MOUSE,(HOOKPROC)MouseProc,gl_hThisInstance,GetCurrentThreadId());
}

void LoadOriginalDll(void)
{
    char buffer[MAX_PATH];
    
    // Getting path to system dir and to d3d8.dll
	::GetSystemDirectory(buffer,MAX_PATH);

	// Append dll name
	strcat(buffer,"\\d3d9.dll");
	
	// try to load the system's d3d9.dll, if pointer empty
	if (!gl_hOriginalDll) gl_hOriginalDll = LoadLibrary(buffer);

	// Debug
	if (!gl_hOriginalDll)
	{

		::ExitProcess(0); // exit the hard way
	}
}
/**********************************************************************************************************************/
LRESULT WINAPI CALLBACK KeyboardProc(int nCode,WPARAM wParam, LPARAM lParam)
{
	LRESULT RetVal;

	if (((DWORD)lParam & 0x40000000) &&(HC_ACTION==nCode))
	{        
		RetVal = 1;
		if (_about && frun == 0)
		{
			_about = 0;
		}
		else
		{
			if (wParam == k_activate)
			{
				if (action)
				{
					_switch = -1;

				}
				else if (!action)
				{
					__alpha = 0;
					_switch = 1;
				}
			}
			else if (wParam == k_save)
			{
				_save = TRUE;
			}
			else if (wParam == k_alphaminus)
			{
				__fadeOut = TRUE;
			}
			else if (wParam == k_alphaplus)
			{
				__fadeIn = TRUE;
			}
			else if (wParam == k_about)
			{
				_about = !_about;
			}
			else if (wParam == k_clock)
			{
				clock_on = !clock_on;
			}
		}
	}
	else
	{
		RetVal = CallNextHookEx( gl_hKbdHook, nCode, wParam, lParam );
	}
	return(RetVal);

}

/**********************************************************************************************************************/
LRESULT WINAPI CALLBACK MouseProc(int nCode,WPARAM wParam, LPARAM lParam)
{
	LRESULT RetVal;
	int i;
	static int _px, _py;
	static int dragX, dragY;
	PMOUSEHOOKSTRUCT mhook;
	static BOOL _dragging = FALSE;
	
	if (!action)
	{
		RetVal = CallNextHookEx( gl_hMouseHook, nCode, wParam, lParam );
	
	}
	else if (HC_ACTION==nCode)
	{        
		RetVal= 1;
		switch (wParam)
		{
			case WM_LBUTTONDOWN:
				mhook = (PMOUSEHOOKSTRUCT)lParam;
				_px = mhook->pt.x; 
				_py = mhook->pt.y; 
				if (_px > __x && _px < __x + __w  && ((_py > __y  && _py < __y + 20) || (_py > __y +40  && _py < __y + __h)) )
				{
					_dragging = TRUE;
				}
				else if (_px > __x && _px < __x + __w  && ((_py > __y + 20  && _py < __y + 40) || (_py > __y +40  && _py < __y + __h)) )
				{
					_dragging = FALSE;
				}
				else
				{
					RetVal = CallNextHookEx( gl_hMouseHook, nCode, wParam, lParam );
				}
				break;
			case WM_LBUTTONUP:
				mhook = (PMOUSEHOOKSTRUCT)lParam;
				_px = mhook->pt.x; 
				_py = mhook->pt.y; 
				if (_px > __x + 24 && _px < __x + __w - 24 && _py > __y + 20  && _py < __y + __h && _dragging == FALSE)
				{
					for (i = 0; i < 21; i++)
					{
						if (_px > __x + 24 + i*20 && _px < __x  + 24 + i*20+20  && _py > __y + 20  && _py < __y + 40)
						{
							Modifiers[order[i]]++;
							if (Modifiers[order[i]] > 3)
								Modifiers[order[i]] = 3;
						}
					}
				}
				else
					RetVal = CallNextHookEx( gl_hMouseHook, nCode, wParam, lParam );
				_dragging = FALSE;
				dragX = 0;
				dragY = 0;
				break;
			case WM_RBUTTONDOWN:
				mhook = (PMOUSEHOOKSTRUCT)lParam;
				_px = mhook->pt.x; 
				_py = mhook->pt.y; 
				if (_px > __x + 24 && _px < __x + __w - 24 && _py > __y + 20  && _py < __y + __h)
				{
					for (i = 0; i < 21; i++)
					{
						if (_px > __x + 24 + i*20 && _px < __x  + 24 + i*20+20  && _py > __y + 20  && _py < __y + 40)
						{
							Modifiers[order[i]]--;
							if (Modifiers[order[i]] < 0)
								Modifiers[order[i]] = 0;
							break;
						}
					}
				}
				else if (_px > __x && _px < __x + __w  && _py > __y  && _py < __y + __h)
				{
					_verbose = !_verbose;
				}
				else
				{
					RetVal = CallNextHookEx( gl_hMouseHook, nCode, wParam, lParam );
				}
				break;
			case WM_MOUSEMOVE:
				mhook = (PMOUSEHOOKSTRUCT)lParam;
				_px = mhook->pt.x; 
				_py = mhook->pt.y; 
				if (_dragging && dragX)
				{
					__x += _px-dragX;
					__y += _py-dragY;
					
					if (__x < 0)
						__x = 0;
					if (__y < 0)
						__y = 0;
					while (__x + 20 > screenX)
						__x--;
					while (__y + 20 > screenY)
						__y--;
					dragX = _px;
					dragY = _py;
				}
				else if (_dragging)
				{
					dragX = _px;
					dragY = _py;
				}
				else
				{
					RetVal = CallNextHookEx( gl_hMouseHook, nCode, wParam, lParam );
				}
				break;
			default:
				RetVal = CallNextHookEx( gl_hMouseHook, nCode, wParam, lParam );
		}
	}
	else
		RetVal = CallNextHookEx( gl_hMouseHook, nCode, wParam, lParam );
	return(RetVal);

}
void ExitInstance() 
{    
	if (gl_hKbdHook)
	{
		UnhookWindowsHookEx(gl_hKbdHook);
		gl_hKbdHook = NULL;
	}
	if (gl_hMouseHook)
	{
		UnhookWindowsHookEx(gl_hMouseHook);
		gl_hMouseHook = NULL;
	}
	// Release the system's d3d9.dll
	if (gl_hOriginalDll)
	{
		FreeLibrary(gl_hOriginalDll);
		gl_hOriginalDll = NULL;  
	}
}

